function cdf= bivgammaspa(xvec,yvec)
cdf=zeros(length(xvec),length(yvec));
for xloop=1:length(xvec), for yloop=1:length(yvec)
  x=xvec(xloop); y=yvec(yloop);
  if x==0 | y==0, cdf(xloop,yloop)=0;
  else
    a3=(-y.^2  + x.*y);h=(x-2*y);a2=(2*h -2*a3);
    a1=(-3 - 3*h  + a3 );a0=(2 + h);
    if a3==0 % we have a quadratic
      c1=a1/a2;c0=a0/a2;
      ts=-c1/2+(-1).^[1:2]*sqrt(c1^2/4-c0);
    else
      c2=a2/a3;c1=a1/a3;c0=a0/a3; q=c1/3-(c2.^2)/9;
      r=1/6*(c1.*c2-3.*c0)-1/27.*c2.^3;
      ts=sqrt(-4*q).*cos((acos(r./sqrt(-q.^3))+2*[1:3]*pi)/3)-c2/3;
    end
    ss=1-1./(x-y+1./(1-ts)); which=(ts<1 & ss<1 & ts+ss<1);
    t=ts(which); s=ss(which); %choose right sp
    t0=(y-2)/y; Kt0=-2*log(1-t0); Kst=-log(1-s)-log(1-t)-log(1-s-t);
    K0t=-2*log(1-t);K0s=-2*log(1-s); x1=real(sign(t0)*sqrt(2*(t0*y-Kt0)));
    w0=real(sign(t)*sqrt(2*(t*y-Kst+K0s)));
    w0star=real(sign(s)*sqrt(2*(s*x-Kst+K0t)));
    if (abs(s)<1e-6 & abs(t)>1e-6) | (abs(t)>1e-6 & w0>w0star+1e-6),
      cdf(xloop,yloop)=bivgammaspa(y,x);
    else
      w=real(sign(s)*sqrt(2*((t-t0)*y+s*x-Kst+Kt0)));
      b=(w0-x1)/w;rho=-b/sqrt(1+b^2); y1=(w-b*x1)/sqrt(1+b^2);
      K_ss=1/(1-s)^2+1/(1-s-t)^2;K_tt=1/(1-t)^2+1/(1-s-t)^2;
      K_st=1/(1-s-t)^2;K_ttt=2*(1-s)^-3+2*(1-s)^-3;
      u=s*sqrt((K_ss-(K_st^2)/K_tt));
      if abs(t)<1e-6
        w1=0; n0=normpdf(x1)*K_ttt/K_tt^(3/2)/6;
      else
        n0=normpdf(x1)*(1/w0-1/(t*sqrt(K_tt)));
      end
      n=normpdf(w)*(1/w-1/u);
      cdf(xloop,yloop)=bvncdf(x1,y1,rho) + normcdf(w0)*n+normcdf(w)*n0+n*n0;
    end
  end
end, end
