function G=dft(g)
% Matlab takes z=exp(2*pi*i/T), even though they say otherwise,
% while my notes (and many books) take z=exp(-2*pi*i/T);
T=length(g); z=exp(-2*pi*i/T); G=zeros(T,1); t=0:(T-1);
for n=0:(T-1),  w=z.^(t*n); G(n+1)=sum(g.*w.'); end
G=G/T;
