function f = expsum (xvec,lamvec)
% pdf of sum of n independent exponential r.v.s with parameter vector lamvec=(lam1,...,lamn)

n=length(lamvec); lamvec=reshape(lamvec,1,n);
for i=1:n
  C(i)=1;
  for j=1:n
    if i ~= j
      C(i) = C(i) * lamvec(j)/(lamvec(j)-lamvec(i));
    end
  end    
end

f=zeros(length(xvec),1);
for i=1:length(xvec)
  x=xvec(i);
  f(i) = sum(C.*lamvec.*exp(-lamvec*x));
end


