function f=gigpdf(x,lambda,chi,psi)
% f=gigpdf(x,lambda,chi,psi)

eta = sqrt(chi/psi); omega = sqrt(chi*psi);
c = 1 / (2 * eta^lambda * besselk(lambda,omega));

p1 = c * x.^(lambda-1); 
p2 = -0.5 * (chi ./ x + psi * x);
f = p1 .* exp(p2);