function f = occpmf(xvec,r,k)
i=0:(k-1); p=(r-i)/r; f = sumgeocf(xvec,p);

%f=0; grd=0.001:0.001:pi; fn=ff(grd,xvec,p); plot(grd,fn)

function f=sumgeocf(xvec,p)
tol=1e-12; xl=length(xvec); f=zeros(xl,1); 
for loop=1:xl
  x=xvec(loop); f(loop)= quadl(@ff,0,pi,tol,0,x,p) / pi;
end


function I=ff(tvec,x,p);
q=1-p; k=length(p); I=zeros(size(tvec));
for loop=1:length(tvec)
  t=tvec(loop);
  cf=exp( k*i*t + sum( log( p./(1-q.*exp(i*t)) ) ) );
  I(loop)=real( exp(-i*t*x) * cf );
end
