function f = pdfinvgamdiff(xvec,a,b)
lo=1e-8; hi=200; tol=1e-8;
xl=length(xvec); f=zeros(xl,1);
for loop=1:xl
  x=xvec(loop);
  f(loop)= quadl(@gammdiffcf,lo,hi,tol,[],x,a,b) / pi;
end;

function I=gammdiffcf(tvec,x,a,b);
for ii=1:length(tvec)
  t=tvec(ii); cf = (1+(t/b).^2).^(-a);
  z  = exp(-i*t*x) .* cf; I(ii) =real(z);
end
