function pmf = schlecht(x,n,p,T)
pmf=quadl(@ff,-T,T,1e-6,0,n,p,x) / 2 / T;

function I=ff(tvec,n,p,x);
q=1-p; I=zeros(size(tvec));
for loop=1:length(tvec)
  t=tvec(loop); cf=(p*exp(i*t)+q)^n;
  I(loop)= ( exp(-i*t*x) * cf );
end
