function f = sumbincf(xvec,n,p)
tol=1e-7; xl=length(xvec); f=zeros(xl,1);
for loop=1:xl
  x=xvec(loop); f(loop)= quadl(@ff,0,pi,tol,0,n,p,x) / pi;
end

function I=ff(tvec,n,p,x);
q=1-p; I=zeros(size(tvec));
for loop=1:length(tvec)
  t=tvec(loop);
  cf=exp( sum( n.*log(p.*exp(i*t) + q) ) ); % ** HERE IS THE C.F.\ **
  I(loop)=real( exp(-i*t*x) * cf );
end
