function u=tukeysolve(a,lambda,xgrid)
u=zeros(length(xgrid),1);
old=0.001; % just a guess
for i=1:length(xgrid)
  x=xgrid(i);
  u(i) = fsolve(@tukeysolve_,old,optimset('Display','Off','tolf',5e-8),x,a,lambda);
  old=u(i); % use previous value as new start value
end

function f=tukeysolve_(u,x,a,lambda)
f = x - (a * u^lambda - (1-u)^lambda)/lambda;


% function u=tukeysolve(a,lambda,xgrid)
% u=zeros(length(xgrid),1);
% old=0.001; % just a guess
% for i=1:length(xgrid)
%   x=xgrid(i);
%   u(i) = fsolve('tukeysolve_',old,[],[],x,a,lambda);
%   old=u(i); % use previous value as new start value
% end
% the matlab function fzero could be used in place of fsolve,
% but the latter performs much better.




